## aethercast 0.1+16.10.20160808

=== CMakeLists.txt ===
project(aethercast C CXX)
cmake_minimum_required(VERSION 2.8.2)

include(CTest)

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to release")
    set(CMAKE_BUILD_TYPE "release")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wno-variadic-macros -Wextra -fPIC")

# By default, all symbols are visible in the library. We strip out things we don't
# want at link time, by running a version script (see unity-scopes.map and the
# setting of LINK_FLAGS below).
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=default")

set(C_AND_CXX_WARNINGS "-pedantic -Wall -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_AND_CXX_WARNINGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_WARNINGS}")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ${C_AND_CXX_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_WARNINGS}")

# -fno-permissive causes warnings with clang, so we only enable it for gcc
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
  option(Werror "Treat warnings as errors" ON)
else()
  option(Werror "Treat warnings as errors" OFF)
endif()

if (${Werror})
    message(STATUS "Treat warnings as errors")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
  endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

include(cmake/FindReadline.cmake)

find_package(Boost COMPONENTS filesystem log serialization system thread program_options)
find_package(PkgConfig)
find_package(Threads)
find_package(LTTngUST REQUIRED)

pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GIO-UNIX REQUIRED gio-unix-2.0)
pkg_check_modules(WDS REQUIRED wds)
pkg_check_modules(MIRCLIENT REQUIRED mirclient)
pkg_check_modules(HYBRIS_MEDIA REQUIRED libmedia)
pkg_check_modules(ANDROID_HEADERS REQUIRED android-headers)

include(cmake/EnableCoverageReport.cmake)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fPIC")

find_program(GDBUS_CODEGEN_EXECUTABLE NAMES gdbus-codegen)

set(AETHERCAST_TRACEPOINT_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/aethercast/tools)

add_subdirectory(conf)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(tools)

set(COVERAGE_IGNORE_FILES
  ${CMAKE_CURRENT_BINARY_DIR}/*
  ${CMAKE_CURRENT_SOURCE_DIR}/tests/*
)

enable_coverage_report(service FILTER ${COVERAGE_IGNORE_FILES})

=== gdbus/CMakeLists.txt ===
# We can't control what gdbus-codegen produces so we have to live with the
# fact that it produces code which doesn't pass -Werror
set(CMAKE_C_FLAGS "-Wall")
set(CMAKE_CXX_FLAGS "-Wall")

execute_process(COMMAND ${GDBUS_CODEGEN_EXECUTABLE}
                        --c-namespace AethercastInterface
                        --c-generate-object-manager
                        --generate-c-code ${CMAKE_CURRENT_BINARY_DIR}/aethercastinterface
                        --interface-prefix org.aethercast.
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../data/org.aethercast.xml)
# gdbus-codegen generates GDBusInterfaceVTables with const as specifier
# but there are methods from both the generated code and gdbus itself
# to retrieve the vtable and modify it. We're changing the set_property
# function of the vtable inside our implementation to apply additional
# policy decisions when certain properties are changed and we want to
# return an error to the user instead of not applying the property
# change silently.
execute_process(COMMAND sed
    -i s:const\ GDBusInterfaceVTable:GDBusInterfaceVTable:g
    ${CMAKE_CURRENT_BINARY_DIR}/aethercastinterface.c)

execute_process(COMMAND ${GDBUS_CODEGEN_EXECUTABLE}
                        --c-namespace WpaSupplicant
                        --c-generate-object-manager
                        --generate-c-code ${CMAKE_CURRENT_BINARY_DIR}/wpasupplicantinterface
                        --interface-prefix fi.w1.wpa_supplicant1.
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../data/fi.w1.wpa_supplicant1.xml)

include_directories(
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
  ${GIO-UNIX_INCLUDE_DIRS}
)

set(GDBUS_WRAPPER_SOURCE
  ${CMAKE_CURRENT_BINARY_DIR}/aethercastinterface.c
  ${CMAKE_CURRENT_BINARY_DIR}/wpasupplicantinterface.c
)

add_library(aethercast-gdbus-wrapper ${GDBUS_WRAPPER_SOURCE})

=== w11tng/CMakeLists.txt ===
add_library(aethercast-test-w11tng
    baseskeleton.cpp
    interfaceskeleton.cpp
    p2pdeviceskeleton.cpp
    peerskeleton.cpp)

AETHERCAST_ADD_TEST(p2pdevicestub_tests p2pdevicestub_tests.cpp aethercast-test-w11tng)
AETHERCAST_ADD_TEST(peerstub_tests peerstub_tests.cpp aethercast-test-w11tng)
AETHERCAST_ADD_TEST(interfacestub_tests interfacestub_tests.cpp aethercast-test-w11tng)
AETHERCAST_ADD_TEST(interfaceselector_tests interfaceselector_tests.cpp aethercast-test-w11tng)
AETHERCAST_ADD_TEST(dhcp_tests dhcp_tests.cpp)
AETHERCAST_ADD_TEST(dhcpleaseparser_tests dhcpleaseparser_tests.cpp)
AETHERCAST_ADD_TEST(informationelement_tests informationelement_tests.cpp)

=== wds/CMakeLists.txt ===
AETHERCAST_ADD_TEST(videoformatselection_tests videoformatselection_tests.cpp)

=== ac/acceptance_tests/CMakeLists.txt ===
add_library(aethercast-test-fwk did_exit_cleanly.cpp)

AETHERCAST_ADD_TEST(aethercast_tests service_tests.cpp aethercast-test-fwk)

=== ac/common/CMakeLists.txt ===
AETHERCAST_ADD_TEST(threadedexecutor_tests threadedexecutor_tests.cpp)
AETHERCAST_ADD_TEST(threadedexecutorfactory_tests threadedexecutorfactory_tests.cpp)
AETHERCAST_ADD_TEST(executorpool_tests executorpool_tests.cpp)

=== ac/dbus/CMakeLists.txt ===
AETHERCAST_ADD_TEST(controllerskeleton_tests controllerskeleton_tests.cpp)
AETHERCAST_ADD_TEST(networkdeviceskeleton_tests networkdeviceskeleton_tests.cpp)

=== ac/integration_tests/CMakeLists.txt ===
configure_file(config.h.in config.h @ONLY)

set(INTEGRATION_TESTS_SOURCE
  config.h
  test_hybris_media_api.cpp
  test_stream_performance.cpp
)

add_executable(aethercast-integration-tests
    ${INTEGRATION_TESTS_SOURCE}
)

target_link_libraries(
  aethercast-integration-tests
  aethercast-core
  aethercast-test-common
  gmock
  gmock_main
  ${Boost_LIBRARIES}
)

install(
  TARGETS aethercast-integration-tests
  RUNTIME DESTINATION sbin
)

install(
  FILES stream-performance-reference.xml
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/aethercast/tests/integration/)

=== ac/mir/CMakeLists.txt ===
set(LIB_SOURCES
    mockmir.cpp
)

add_library(aethercast-test-mir ${LIB_SOURCES})

AETHERCAST_ADD_TEST(screencast_tests screencast_tests.cpp aethercast-test-mir)
AETHERCAST_ADD_TEST(streamrenderer_tests streamrenderer_tests.cpp)
AETHERCAST_ADD_TEST(sourcemediamanager_tests sourcemediamanager_tests.cpp)

=== ac/report/CMakeLists.txt ===
AETHERCAST_ADD_TEST(reportfactory_tests reportfactory_tests.cpp)

=== ac/video/CMakeLists.txt ===
AETHERCAST_ADD_TEST(h264analyzer_tests h264analyzer_tests.cpp)
AETHERCAST_ADD_TEST(buffer_tests buffer_tests.cpp)
AETHERCAST_ADD_TEST(videoformat_tests videoformat_tests.cpp)

=== 3rd_party/process-cpp-minimal/src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>
add_library(
  process-cpp
  
  core/posix/backtrace.h
  core/posix/backtrace.cpp

  core/posix/child_process.cpp
  core/posix/exec.cpp
  core/posix/fork.cpp
  core/posix/process.cpp
  core/posix/process_group.cpp
  core/posix/signal.cpp
  core/posix/signalable.cpp
  core/posix/standard_stream.cpp
  core/posix/wait.cpp
  core/posix/this_process.cpp

  core/posix/linux/proc/process/oom_adj.cpp
  core/posix/linux/proc/process/oom_score.cpp
  core/posix/linux/proc/process/oom_score_adj.cpp
  core/posix/linux/proc/process/stat.cpp

  core/testing/cross_process_sync.cpp
  core/testing/fork_and_run.cpp
)

target_link_libraries(
  process-cpp

  ${Boost_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

=== debian/changelog ===
aethercast (0.1+16.10.20160808-0ubuntu3) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 18 Sep 2016 10:24:54 +0000

aethercast (0.1+16.10.20160808-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 11:57:06 +0000

aethercast (0.1+16.10.20160808-0ubuntu1) yakkety; urgency=medium

  [ Simon Fels ]
  * Fix integration tests
  * Add URfkill support to manage kill switches on selected devices
  * Switch to new object path for Screen service as its now provided by
    repowerd
  * Fix RTSP debugging and device state update reporting
  * Fix several issues which prevent the Mii Box from connecting (LP:
    #1576331, #1597449)
  * Use a different network device on some devices for sending private
    driver commands

 -- morphis <simon.fels@canonical.com>  Mon, 08 Aug 2016 09:00:30 +0000

aethercast (0.1+16.10.20160607-0ubuntu1) yakkety; urgency=medium

  [ Simon Fels ]
  * Enable builds on arm64
  * Cleanup various things

 -- morphis <simon.fels@canonical.com>  Tue, 07 Jun 2016 08:27:42 +0000

aethercast (0.1+16.10.20160520.1-0ubuntu1) yakkety; urgency=medium

  * Some times socket output buffer was full and sending returned an
    EAGAIN error. Solved by making the socket blocking, as anyway we
    have a dedicated thread for sending and you will not be blocked in a
    datagram socket for long. LP: #1579773. (LP: #1579773)

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 20 May 2016 08:17:44 +0000

aethercast (0.1+16.04.20160506.1-0ubuntu1) xenial; urgency=medium

  [ Alfonso Sanchez-Beato ]
  * Fix for Microsoft dongle

  [ Simon Fels ]
  * Add short delay before starting the screencast stream (LP: #1578941)

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 06 May 2016 15:11:08 +0000

aethercast (0.1+16.04.20160429.2-0ubuntu1) xenial; urgency=medium

  [ Simon Fels ]
  * First release of aethercast in Ubuntu. This brings basic WiFi Display
    support to Ubuntu Touch for selected target devices.
  * Adapt for new screencast API in Mir 0.22
  * Add DBus API definition for external input providers.
  * Add DBus API specification and service usage instructions. added:
    docs/ docs/device-api.txt docs/manager-api.txt docs/overview.txt
    docs/usage.txt
  * Add DHCP client support for P2P client mode
  * Add LTTng support for aethercast
  * Add a network manager implementation to use the DBus interface of
    wpa-supplicant.
  * Add build dep on libboost-iostreams-dev Use PR_SET_CHILD_SUBREAPER
    to reap all of our children when we going down. Send SIGKILL when
    parent dies. Let supplicant wait until we connect over the socket
    with it.
  * Add build dependency on gstreamer-1.0
  * Add command line argument to enable debugging
  * Add comment about firmware loading on startup
  * Add cross-compilation support.
  * Add debug support for DHCP
  * Add dhclient wrapper and use it after group was started removed:
    src/gdhcp/ src/gdhcp/client.c src/gdhcp/common.c src/gdhcp/common.h
    src/gdhcp/gdhcp.h src/gdhcp/ipv4ll.c src/gdhcp/ipv4ll.h
    src/gdhcp/server.c src/gdhcp/unaligned.h added: src/dhcpclient.cpp
    src/dhcpclient.h
  * Add dict entry reading for supplicant message
  * Add factory to construct media managers added:
    src/mediamanagerfactory.cpp src/mediamanagerfactory.h
  * Add first part of things needed for Miracast support added:
    src/basesourcemediamanager.cpp src/basesourcemediamanager.h
    src/miracastsource.cpp src/miracastsource.h
    src/miracastsourceclient.cpp src/miracastsourceclient.h
    src/mirsourcemediamanager.cpp src/mirsourcemediamanager.h
  * Add hardware encoding and video streaming support.
  * Add initial debian packaging added: debian/ debian/changelog
    debian/compat debian/control debian/copyright debian/miracast-
    service/ debian/miracast-service.debhelper.log debian/miracast-
    service/usr/ debian/miracast-service/usr/bin/ debian/miracast-
    service/usr/bin/miracast-service debian/miracast-service/usr/share/
    debian/miracast-service/usr/share/doc/ debian/miracast-
    service/usr/share/doc/miracast-service/ debian/miracast-
    service/usr/share/doc/miracast-service/changelog.gz debian/miracast-
    service/usr/share/doc/miracast-service/copyright debian/rules
    debian/source/ debian/source/format
  * Add integration tests to ensure performance doesn't regress
  * Add missing COPYING and README files added: COPYING README.md
  * Add missing WiFi display device info class added:
    src/wfddeviceinfo.h
  * Add missing warning for null media manager implementation
  * Add more verbose output for supplicant
  * Add proper repsawning of supplicant when it exists
  * Add set of tests for WpaSupplicantCommandQueue implementation.
    Convert WpaSupplicantMessage tests to gtest. removed:
    src/wpa/wpasupplicantmessage_test.cpp added: tests/wpa/
    tests/wpa/CMakeLists.txt
    tests/wpa/wpasupplicantcommandqueue_test.cpp
    tests/wpa/wpasupplicantmessage_test.cpp
  * Add support for persistent connections
  * Add unix signal handler added: src/unixsignalhandler.cpp
    src/unixsignalhandler.h
  * Add upstart job and install it added: conf/CMakeLists.txt
    conf/miracast-service.conf.in
  * Changing logging format.
  * Check manager role rather than peer one and set sane default
  * Check response status when attaching to supplicant for events
  * Cleanup miracast source class a bit
  * Configure source media manager once we ready
  * Consider selected H264 profile when setting up encoder
  * Convert even more noncopyable.hpp references
  * Convert remaining references to org.wds to org.aethercast.
  * Correctly handle peer lost message
  * Depend on correct wds soversion
  * Depend on wpasupplicant at installation time and on libwds1 at build
    time until wds is properly updated.
  * Detect client disconnects on RTSP channel


=== debian/control ===
Source: aethercast
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Simon Fels <simon.fels@canonical.com>
Build-Depends: android-headers-19 (>= 23),
               cmake,
               debhelper (>= 9),
               dh-apparmor,
               dbus,
               google-mock,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-log-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
# boost log needs exactly one symbol from boost-thread for resolving
# thread-specific storage locations.
               libboost-thread-dev,
               libglib2.0-dev,
               libgtest-dev,
               libhybris-dev,
               liblttng-ust-dev,
               libmedia-dev,
               libmirclient-dev,
               libreadline-dev,
               libreadline6-dev,
               libwds-dev,
               pkg-config
Standards-Version: 3.9.4
Homepage: http://launchpad.net/aethercast
# If you aren't a member of ~phablet-team but need to upload packaging changes,
# just go ahead.  ~phablet-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/aethercast/trunk
Vcs-Browser: http://bazaar.launchpad.net/aethercast/trunk/files

Package: aethercast
Architecture: i386 amd64 armhf arm64
Depends: ${misc:Depends},
         ${shlibs:Depends},
         aethercast-tools,
         isc-dhcp-server,
         isc-dhcp-client,
         wpasupplicant
Description: Display casting service
 A management service that streams current device screen content
 to a remote display. This service supports several different
 protocols such as Miracast.

Package: aethercast-tools
Architecture: i386 amd64 armhf arm64
Depends: ${misc:Depends},
         ${shlibs:Depends},
         isc-dhcp-server,
         isc-dhcp-client,
         wpasupplicant
Description: Tools for the display casting service
 A management service that streams current device screen content
 to a remote display. This service supports several different
 protocols such as Miracast.
 .
 This package contains small utilities that assist in working with
 the display streaming stack.

Package: aethercast-tests
Architecture: i386 amd64 armhf arm64
Depends: ${misc:Depends},
         ${shlibs:Depends},
         isc-dhcp-server,
         isc-dhcp-client,
         wpasupplicant
Description: Tests for the display casting service
 A management service that streams current device screen content
 to a remote display. This service supports several different
 protocols such as Miracast.
 .
 This package contains tests programs that check the service and
 the system for confirmity with what aethercast requires to work
 properly.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

%:
	dh $@ --parallel --fail-missing

override_dh_install:
	dh_install
	dh_apparmor -paethercast --profile-name=usr.sbin.dhcpd

## aethercast 0.1+17.04.20170328.1

=== CMakeLists.txt ===
add_subdirectory(gdbus)

# Make sure that generated gdbus header files can be found
include_directories(${CMAKE_CURRENT_BINARY_DIR}/gdbus)

set(AETHERCAST_DHCP_HELPER "/usr/sbin/aethercast-dhcp-helper")
set(DHCP_SERVER_PATH "/usr/sbin/dhcpd")
set(DHCP_CLIENT_PATH "/sbin/dhclient")

configure_file(ac/config.h.in ac/config.h @ONLY)
configure_file(w11tng/config.h.in w11tng/config.h @ONLY)

set(HEADERS
  ac/glib_wrapper.h

  ac/ip_v4_address.h
  ac/keep_alive.h
  ac/mac_address.h
  ac/shared_gobject.h
  ac/keep_alive.h
  ac/config.h

  ac/common/executable.h
  ac/common/executor.h
  ac/common/executorfactory.h

  ac/network/types.h

  ac/report/lttng/utils.h
  ac/report/lttng/encoderreport_tp.h
  ac/report/lttng/rendererreport_tp.h
  ac/report/lttng/packetizerreport_tp.h
  ac/report/lttng/senderreport_tp.h

  ac/video/encoderreport.h
  ac/video/rendererreport.h
  ac/video/packetizerreport.h
  ac/video/senderreport.h
  ac/video/bufferproducer.h

  ac/streaming/packetizer.h

  w11tng/config.h
)

set(SOURCES
  ac/types.cpp
  ac/utils.cpp
  ac/networkutils.cpp
  ac/mediamanagerfactory.cpp
  ac/basesourcemediamanager.cpp
  ac/logger.cpp
  ac/forwardingcontroller.cpp
  ac/forwardingnetworkdevice.cpp
  ac/controller.cpp
  ac/service.cpp
  ac/sourcemanager.cpp
  ac/sourceclient.cpp
  ac/networkmanager.cpp
  ac/networkmanagerfactory.cpp
  ac/networkdevice.cpp

  ac/dbus/helpers.cpp
  ac/dbus/errors.cpp
  ac/dbus/controllerskeleton.cpp
  ac/dbus/networkdeviceskeleton.cpp

  ac/common/executorpool.cpp
  ac/common/threadedexecutor.cpp
  ac/common/threadedexecutorfactory.cpp

  ac/network/stream.cpp
  ac/network/udpstream.cpp

  ac/report/reportfactory.cpp
  ac/report/reportfactory.h

  ac/report/null/nullreportfactory.cpp
  ac/report/null/encoderreport.cpp
  ac/report/null/rendererreport.cpp
  ac/report/null/packetizerreport.cpp
  ac/report/null/senderreport.cpp
  ac/report/logging/loggingreportfactory.cpp
  ac/report/logging/encoderreport.cpp
  ac/report/logging/rendererreport.cpp
  ac/report/logging/packetizerreport.cpp
  ac/report/logging/senderreport.cpp
  ac/report/lttng/lttngreportfactory.cpp
  ac/report/lttng/tracepointprovider.cpp
  ac/report/lttng/encoderreport.cpp
  ac/report/lttng/rendererreport.cpp
  ac/report/lttng/packetizerreport.cpp
  ac/report/lttng/senderreport.cpp

  ac/video/videoformat.cpp
  ac/video/buffer.cpp
  ac/video/bufferqueue.cpp
  ac/video/utils.cpp
  ac/video/utils_from_android.cpp
  ac/video/baseencoder.cpp
  ac/video/h264analyzer.cpp
  ac/video/displayoutput.cpp

  ac/streaming/transportsender.cpp
  ac/streaming/mpegtspacketizer.cpp
  ac/streaming/rtpsender.cpp
  ac/streaming/mediasender.cpp

  ac/mir/sourcemediamanager.cpp
  ac/mir/screencast.cpp
  ac/mir/streamrenderer.cpp

  ac/android/h264encoder.cpp

  ac/systemcontroller.cpp

  ac/ubuntu/unity.cpp
  ac/ubuntu/systemcontroller.cpp
  ac/ubuntu/unitydisplaylock.cpp

  w11tng/networkmanager.cpp
  w11tng/rfkillmanager.cpp
  w11tng/kernelrfkillmanager.cpp
  w11tng/urfkillmanager.cpp
  w11tng/networkdevice.cpp
  w11tng/interfaceselector.cpp
  w11tng/p2pdevicestub.cpp
  w11tng/managerstub.cpp
  w11tng/peerstub.cpp
  w11tng/interfacestub.cpp
  w11tng/groupstub.cpp
  w11tng/informationelement.cpp
  w11tng/dhcpleaseparser.cpp
  w11tng/dhcpclient.cpp
  w11tng/dhcpserver.cpp
  w11tng/processexecutor.cpp
  w11tng/filemonitor.cpp
  w11tng/wififirmwareloader.cpp
  w11tng/hostname1stub.cpp
)

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
  ${GIO-UNIX_INCLUDE_DIRS}
  ${WDS_INCLUDE_DIRS}
  ${HYBRIS_MEDIA_INCLDUE_DIRS}
  ${ANDROID_HEADERS_INCLUDE_DIRS}
  ${MIRCLIENT_INCLUDE_DIRS}
  ${EGL_INCLUDE_DIRS}
  ${GLESV2_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}/src
  ${CMAKE_CURRENT_BINARY_DIR}/src/w11tng
)

add_library(aethercast-core ${SOURCES} ${HEADERS})
target_compile_definitions(aethercast-core PUBLIC
    "-DAETHERCAST_TRACEPOINT_LIB_INSTALL_PATH=\"${CMAKE_INSTALL_PREFIX}/${AETHERCAST_TRACEPOINT_LIB_INSTALL_DIR}\"")
target_link_libraries(aethercast-core
  aethercast-gdbus-wrapper
  ${Boost_LDFLAGS}
  ${Boost_LIBRARIES}
  ${GLIB_LDFLAGS}
  ${GLIB_LIBRARIES}
  ${GIO_LDFLAGS}
  ${GIO_LIBRARIES}
  ${GIO-UNIX_LDFLAGS}
  ${GIO-UNIX_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${WDS_LDFLAGS}
  ${WDS_LIBRARIES}
  ${HYBRIS_MEDIA_LDFLAGS}
  ${HYBRIS_MEDIA_LIBRARIES}
  ${MIRCLIENT_LDFLAGS}
  ${MIRCLIENT_LIBRARIES}
  ${EGL_LDFLAGS}
  ${EGL_LIBRARIES}
  ${GLESV2_LDFLAGS}
  ${GLESV2_LIBRARIES}
  -ldl
)

add_library(aethercast-lttng SHARED ac/report/lttng/tracepoints.c)
target_link_libraries(aethercast-lttng
    ${LTTNG_UST_LIBRARIES}
)

install(TARGETS aethercast-lttng
  LIBRARY DESTINATION ${AETHERCAST_TRACEPOINT_LIB_INSTALL_DIR}
)

add_executable(aethercast ac/main.cpp)
target_link_libraries(aethercast aethercast-core)

install(
  TARGETS aethercast
  RUNTIME DESTINATION sbin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib/static
)

add_subdirectory(client)

=== ac/CMakeLists.txt ===
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
  ${GIO-UNIX_INCLUDE_DIRS}
  ${GST_INCLUDE_DIRS}
  ${WDS_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_BINARY_DIR}
)

AETHERCAST_ADD_TEST(mediamanagerfactory_tests mediamanagerfactory_tests.cpp)
AETHERCAST_ADD_TEST(forwardingcontroller_tests forwardingcontroller_tests.cpp)
AETHERCAST_ADD_TEST(forwardingnetworkdevice_tests forwardingnetworkdevice_tests.cpp)
AETHERCAST_ADD_TEST(networkdevice_tests networkdevice_tests.cpp)
AETHERCAST_ADD_TEST(networkmanagerfactory_tests networkmanagerfactory_tests.cpp)
AETHERCAST_ADD_TEST(networkutils_tests networkutils_tests.cpp)

add_subdirectory(acceptance_tests)
add_subdirectory(integration_tests)
add_subdirectory(dbus)
add_subdirectory(streaming)
add_subdirectory(video)
add_subdirectory(mir)
add_subdirectory(android)
add_subdirectory(common)
add_subdirectory(report)

=== client/CMakeLists.txt ===
set(SOURCES
    main.cpp
    application.cpp
)

link_directories(
  ${GLIB_LIBRARY_DIRS}
  ${GIO_LIBRARY_DIRS}
  ${GIO-UNIX_LIBRARY_DIRS}
)

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
  ${GIO-UNIX_INCLUDE_DIRS}
  ${READLINE_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}/../
  ${CMAKE_CURRENT_BINARY_DIR}/src
)

add_executable(aethercastctl ${SOURCES})
target_link_libraries(aethercastctl
  aethercast-gdbus-wrapper
  ${Boost_LIBRARIES}
  ${GLIB_LIBRARIES}
  ${GIO_LIBRARIES}
  ${GIO-UNIX_LIBRARIES}
  ${READLINE_LIBRARIES}
  -ldl
)

install(
  TARGETS aethercastctl
  RUNTIME DESTINATION bin
)

=== 3rd_party/lxc-nl/CMakeLists.txt ===
set(SOURCES
    nl.c
    network.c
)

# We copied these code parts from LXC and don't want to fix any compile
# warnings in it.
set(CMAKE_C_FLAGS "-Wall")
set(CMAKE_CXX_FLAGS "-Wall")

add_library(lxc-network ${SOURCES})

=== 3rd_party/process-cpp-minimal/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 2.8)

project(process-cpp)

find_package(Boost COMPONENTS iostreams system REQUIRED)
find_package(Threads REQUIRED)

include(GNUInstallDirs)

set(PROCESS_CPP_VERSION_MAJOR 2)
set(PROCESS_CPP_VERSION_MINOR 0)
set(PROCESS_CPP_VERSION_PATCH 0)

include(CTest)

include_directories(
  include/
  src/
  ${Boost_INCLUDE_DIRS}
)

add_subdirectory(src)

=== ac/android/CMakeLists.txt ===
set(LIB_SOURCES
    mockmedia.cpp
    mockencoderreport.cpp
)

add_library(aethercast-test-android ${LIB_SOURCES})

AETHERCAST_ADD_TEST(h264encoder_tests h264encoder_tests.cpp aethercast-test-android)

=== ac/streaming/CMakeLists.txt ===
AETHERCAST_ADD_TEST(mpegtspacketizer_tests mpegtspacketizer_tests.cpp)
AETHERCAST_ADD_TEST(mediasender_tests mediasender_tests.cpp)
AETHERCAST_ADD_TEST(rtpsender_tests rtpsender_tests.cpp)

=== debian/changelog ===
aethercast (0.1+17.04.20170328.1-0ubuntu1) zesty; urgency=medium

  [ Balint Reczey ]
  * Fix zesty FTBFS by replacing the bundling of googletest
    with find_package from cmake-extra. (LP: #1640317, LP: #1644062)
  * Fix installation to multiarch path during build

 -- morphis <simon.fels@canonical.com>  Tue, 28 Mar 2017 05:51:12 +0000

aethercast (0.1+16.10.20160808-0ubuntu4) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:07:20 +0000

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 XSBC-Original-Maintainer: Simon Fels <simon.fels@canonical.com>
 Build-Depends: android-headers-19 (>= 23),
                cmake,
+               cmake-extras,
                debhelper (>= 9),
                dh-apparmor,
                dbus,

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,9 @@
 %:
 	dh $@ --parallel --fail-missing
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
+
 override_dh_install:
 	dh_install
 	dh_apparmor -paethercast --profile-name=usr.sbin.dhcpd
